require "Scripts/Functions/GetEntityNeighbors.lua"

Script.movePos = Vec3(0)--Vec3 "Move Position"
Script.speed = 0.05 --float "Speed"
Script.closeDelay = 4000 --float "Close delay"
Script.locked = false --bool "Locked"

Script.state = "closed"
Script.moveDir = Vec3(0)

function Script:Start()
	self.moveDir = self.movePos:Normalize()
	self.initPos = self.entity:GetPosition()
	self.closeTime = 0
end

function Script:UpdateWorld()
	if self.state == "closed" then
		--local entities = GetEntityNeighbors(self.entity, 1, true)
		--print(#entities)
		local vec = self.entity:GetPosition() - _G.player.entity:GetPosition()
		if vec:Length() < 3 and self.locked == false then
			self.state = "opening"
		end
		--[[
		for k,v in pairs(entities) do
			if v.script.health ~= nil then
			--if v == _G.player then
				self.state = "opening"
				print("open")
			end
		end
		]]

	elseif self.state == "opening" then
		self.entity:Move(self.moveDir * self.speed)
		local vec = self.entity:GetPosition() - (self.movePos + self.initPos)
		if vec:Length() < 0.01 then
			self.state = "opened"
			self.closeTime = Time:GetCurrent() + self.closeDelay
		end

	elseif self.state == "opened" then
		if self.closeTime <= Time:GetCurrent() then
			self.state = "closing"
		end

	elseif self.state == "closing" then
		self.entity:Move(self.moveDir * -self.speed)
		local vec = self.entity:GetPosition() - self.initPos
		if vec:Length() < 0.01 then
			self.state = "closed"
			self.entity:SetPosition(self.initPos)
		end
	end
end


function Script:Unlock() --in
	self.locked = false
end