require "Scripts/Animation/AnimationManager.lua"

--Animation sequences
Script.sequence={} 
Script.sequence.idle=0
Script.sequence.attack=1
Script.sequence.death=2

Script.stat = "idle"

Script.health = 10
Script.nextAttackTime = 0
Script.throwTime = 0


function Script:Start()
	self.animationmanager = AnimationManager:Create(self.entity)
	self.animationmanager:SetAnimationSequence(self.sequence.idle, 0.05, 0)

	self.nextAttackTime = Time:GetCurrent() + 1500
end


function Script:UpdateWorld()
	if self.stat == "dead" then
		return
	end

	--Rotate to face target
	local p0 = self.entity:GetPosition(true)
	local p1 = _G.player.entity:GetPosition(true)
	local yaw = Math:ATan2(p1.x-p0.x,p1.z-p0.z)
	yaw = Math:CurveAngle(yaw, self.entity:GetRotation().y, 10)

	if self.nextAttackTime <= Time:GetCurrent() and _G.player.isDead == false then
		local pickinfo = PickInfo()
		--local zaxis = Transform:Vector(0,0,1, self.entity, nil)
		local target = _G.player.entity:GetPosition() + Vec3(0,1.3,0)
		_G.player.hudModel:Hide()
		if World:GetCurrent():Pick(self.entity:GetPosition()+Vec3(0,1.3,0), target, pickinfo, 0, true, Collision.Prop) then
			if pickinfo.entity == _G.player.entity then
				self.animationmanager:SetAnimationSequence(self.sequence.attack, 0.03, 200, 1)
				self.throwTime  = Time:GetCurrent() + 300
			end
		end
		_G.player.hudModel:Show()
		self.nextAttackTime = Time:GetCurrent() + 1500
	end

	if self.throwTime ~= 0 and self.throwTime <= Time:GetCurrent() then
		FlaskManager:Throw(self.entity:GetPosition()+Vec3(0,1.3,0), self.entity:GetRotation())
		self.throwTime = 0
	end

	self.entity:SetInput(yaw, 0, 0, 0, false, 1.0)
end


function Script:Draw()
	self.animationmanager:Update()
end


function Script:TakeDamage(damage)
	self.health = self.health - damage
	if self.health <= 0 then
		self.animationmanager:SetAnimationSequence(self.sequence.death, 0.05, 400, 1)
		self.UpdatePhysics = nil--This will remove the entity from the script UpdatePhysics list
		self.entity:SetCollisionType(0)
		self.entity:SetMass(0)
		self.entity:SetPhysicsMode(Entity.RigidBodyPhysics)
		self.stat = "dead"
	end
end