--[[
function Script:Start()
	window:SetMousePosition(screenCenter.x, screenCenter.y)
end
]]--

--[[
function Script:UpdateMatrix()
	
end
]]--

--[[
function Script:UpdateWorld()
	
end
]]--

local context = Context:GetCurrent()
local screenCenter = {x=context:GetWidth()/2, y=context:GetHeight()/2}
Script.speed = 0

Script.inventory = {}
Script.currentSlot = 1

Script.health = 100
Script.isDead = false
Script.isClear = false

-- Flask objects
--local flask = Prefab:Load("Prefabs/Props/Flask_Attack.pfb")
--[[
Script.flaskList = {}
for i=1, 10 do
	--Script.flaskList[i] = flask:Instance()
end
]]

function Script:Start()
	local window=Window:GetCurrent()
	window:SetMousePosition(screenCenter.x, screenCenter.y)

	self.camera = self.entity:FindChild("Camera")

	-- HUD model
	self.hudModel = Prefab:Load("Prefabs/Props/Flask.pfb")
	self.hudModel:SetPosition(self.camera:GetPosition(true))
	self.hudModel:Move(0,-0.5,0.7)
	self.hudModel:SetParent(self.camera)
	self.hudModel:SetCollisionType(Collision.None)
	self.hudModel:GetChild(0):SetCollisionType(Collision.None)

	self.speed = self.speed + 1

	HUD.player = self

	_G.player = self
	_G.camera = self.camera
end

function Script:UpdatePhysics()

	if self.isDead == true or self.isClear == true then
		self.entity:SetInput(self.entity:GetRotation().y, 0, 0, 0, false, 5.0)
		return
	end

	local window = Window:GetCurrent()

	local currentMousePos = window:GetMousePosition()
	local mx = (currentMousePos.x - screenCenter.x) * 0.15
	local my = (currentMousePos.y - screenCenter.y) * 0.15
	window:SetMousePosition(screenCenter.x, screenCenter.y)

	local angle = self.entity:GetRotation().y + mx

	local camrot = self.camera:GetRotation()
	self.camera:SetRotation(camrot + Vec3(my, 0, 0))



	local forward = 0
	local strafe = 0
	local jump = 0
	local move = Vec3(0,0,0)

	--Code for detecting key hits for movement and attacks
	if (window:KeyDown(Key.W)) then move.z = 1 end
	if (window:KeyDown(Key.S)) then move.z = -1 end
	if (window:KeyDown(Key.A)) then move.x = -1 end
	if (window:KeyDown(Key.D)) then move.x = 1 end
	move = move:Normalize()

	if window:KeyHit(Key.Space) then jump = 8 end

	self.entity:SetInput(angle, move.z * 8, move.x * 8, jump, false, 5.0)
end


function Script:UpdateWorld()

	local window = Window:GetCurrent()

	if self.isDead == true then
		local v = self.entity:GetPosition(true) - self.camera:GetPosition(true)
		if v:Length() > 0.1 then
			self.camera:SetPosition(self.camera:GetPosition()+Vec3(0,-0.08,0))
		end

		if window:KeyHit(Key.R) then
			App:Restart()
		end
		return
	end

	if self.isClear == true  then
		return
	end


	-- Change inventoy
	--[[
	if window:KeyHit(Key.Q) then
		self.currentSlot = self.currentSlot - 1
		if self.currentSlot < 1 then
			self.currentSlot = #self.inventory
		end
	end
	if  window:KeyHit(Key.E) then
		self.currentSlot = self.currentSlot + 1
		if self.currentSlot > #self.inventory then
			self.currentSlot = 1
		end
	end
	]]

	-- Fire
	if window:MouseHit(1) then
		--[[
		--Prefab:Load("Prefabs/Player.pfb");
		local bullet = Prefab:Load("Prefabs/Weapons/Bullet.pfb");
		bullet:SetPosition(self.camera:GetPosition(true))
		bullet:SetRotation(self.camera:GetRotation(true))
		bullet:Move(0, 0, 1)
		bullet:SetCollisionType(0)
		]]
		if self.inventory[self.currentSlot] == 1 then
			local throw = FlaskManager:Throw(self.hudModel:GetPosition(true), self.hudModel:GetRotation(true))

			if throw == true then
				table.remove(self.inventory, self.currentSlot)
				if self.currentSlot > #self.inventory then
					self.currentSlot = #self.inventory
				end
				if self.currentSlot < 1 then
					self.currentSlot = 1
				end
			end
		end
		--flask:SetPosition(self.hudModel:GetPosition(true))
		--flask:Release()
	end

	-- HUD Weapon
	if #self.inventory ~= 0 then
		self.hudModel:Show()
	else
		self.hudModel:Hide()
	end
end


function Script:Collision( entity, position, normal, speed )
	if entity.script ~= nil then
		if entity.script.class == "item" and entity.script.picked == nil then
			--entity:Release()
			entity:Hide()
			--[[
			for i=0, 3 do
				self.inventory[#self.inventory+1] = 1
			end
			]]
			self.inventory[#self.inventory+1] = 1
			self.inventory[#self.inventory+1] = 1
			entity.script.picked = true
			_G.snd_item:Play()
		end
	end
end


function Script:TakeDamage(damage)
	self.health = self.health - damage
	if self.health <= 0 then
		self.hudModel:Hide()
		self.isDead = true
		self.health = 0
	end
end

--[[
function Script:Collision(entity, position, normal, speed)
	
end
]]--

--[[
function Script:Draw()
	
end
]]--

--[[
function Script:DrawEach(camera)
	
end
]]--

--[[
function Script:Release()
	
end
]]--

--[[
function Script:Cleanup()
	
end
]]--